<script lang="ts">
  import { slice } from "lodash-es";
  import { takeWhile } from "lodash-es";

  import { formatMoney, sortedByRank, PlayerSummary } from "../utils";

  export let players: Player[];

  let sortedPlayers: PlayerSummary[];
  $: sortedPlayers = sortedByRank(players);

  $: winners = takeWhile(
    sortedPlayers,
    (p) => p.rankValue === sortedPlayers[0]?.rankValue
  );
</script>

<div class="wrapper">
  <h2>
    {#if winners.length === 1}
      <gs6-user playerid={winners[0].id} /> wins!
    {:else if winners.length === 2}
      <gs6-user playerid={winners[0].id} /> and
      <gs6-user playerid={winners[1].id} /> win!
    {:else if winners.length > 2}
      {#each winners.slice(0, winners.length - 1) as winner}
        <gs6-user playerid={winner.id} />,{" "}
      {/each} and <gs6-user playerid={winners[winners.length - 1].id} /> win!
    {/if}
  </h2>

  <table>
    <thead>
      <tr>
        <th>#</th>
        <th class="player-name">Player</th>
        <th>Sales</th>
        <th>
          Cash
          <br />
          <small>(tiebreaker)</small>
        </th>
        <th>Total</th>
      </tr>
    </thead>
    <tbody>
      {#each sortedPlayers as player (player.id)}
        <tr>
          <td>
            {sortedPlayers.filter((p) => p.rankValue > player.rankValue)
              .length + 1}
          </td>
          <td class="player-name">
            <gs6-user userid={player.id} />
          </td>
          <td>{formatMoney(player.salesSum)}</td>
          <td>{formatMoney(player.cash)}</td>
          <td>{formatMoney(player.total)}</td>
        </tr>
      {/each}
    </tbody>
  </table>
</div>

<style>
  .wrapper {
    padding: 0.5rem 1rem;
  }

  h2 {
    text-align: center;
    margin-top: 1em;
    margin-bottom: 1.5em;
  }
  table {
    border-collapse: collapse;
    text-align: center;
  }
  th {
    font-weight: 500;
    border-bottom: 1px solid #0007;
  }
  th small {
    color: #0009;
  }
  td,
  th {
    padding: 0.5em 1.5em;
  }
  thead th {
    padding-bottom: 0.25em;
  }
  tbody tr:first-child td {
    padding-top: 1em;
  }

  .player-name {
    text-align: left;
  }
</style>
